# various databases for benchmarking and monitoring stack

services:

  # databases we want to query
  # start one at a time in benchmarking scripts
  # ---------------------------
  timescaledb:
    image: timescale/timescaledb:2.4.1-pg12
    container_name: timescaledb
    ports:
    - "5432:5432"
    environment:
      POSTGRES_HOST_AUTH_METHOD: trust

  cratedb:
    image: crate:4.6.1
    container_name: cratedb
    ports:
    - "5432:5432"
    command: [-Cdiscovery.type=single-node]

  mongo:
    container_name: mongo
    image: mongo:4.2.16
    ports:
    - "27017:27017"

  clickhouse:
  clickhouse: &clickhouse
    image: yandex/clickhouse-server:21.8.4
    container_name: clickhouse
    ports:
    - "9000:9000"
    ulimits:
      nofile:
        soft: 262144
        hard: 262144

  clickhouse-single-table-naive:
    <<: *clickhouse
    container_name: clickhouse-single-table-naive

  clickhouse-single-table-refined:
    <<: *clickhouse
    container_name: clickhouse-single-table-refined


  # cadvisor and prometheus for monitoring
  # ---------------------------------------

  prometheus:
    image: prom/prometheus:latest
    container_name: prometheus
    ports:
    - 9090:9090
    environment:
      PROMETHEUS_CONFIG: |
        scrape_configs:
        - job_name: cadvisor
          scrape_interval: 5s
          static_configs:
          - targets:
            - cadvisor:8080
    entrypoint: ""
    command: >
      /bin/sh -c "echo \"$$PROMETHEUS_CONFIG\" > /etc/prometheus/prometheus.yml &&
      /bin/prometheus --config.file=/etc/prometheus/prometheus.yml 
      --storage.tsdb.path=/prometheus 
      --web.console.libraries=/etc/prometheus/console_libraries 
      --web.console.templates=/etc/prometheus/consoles
      --query.lookback-delta=20s"
    depends_on:
    - cadvisor

  cadvisor:
    image: gcr.io/cadvisor/cadvisor:v0.39.2
    container_name: cadvisor
    privileged: true
    ports:
    - 8080:8080
    volumes:
    - /:/rootfs:ro
    - /var/run:/var/run:rw
    - /sys:/sys:ro
    - /var/lib/docker/:/var/lib/docker:ro
    - /dev/disk/:/dev/disk:ro

  # benchmark runner
  # start the runner to orchestrate everthing else
  # should be run from the host machine to orchestrate other containers
  # -----------------
  runner:
    build:
      context: .
    network_mode: host
    volumes:
    - /var/run/docker.sock:/var/run/docker.sock
    - /var/lib/docker:/var/lib/docker:ro
    - ./results:/tsbs/results
    # default environment vars (quick run) - change these to change the experiment
    environment:
      NUM_WORKERS: "${NUM_WORKERS:-4}"
      USE_CASE: "${USE_CASE:-cpu-only}"
      SCALE: "${SCALE:-100}"
      DATABASE_NAMES: "${DATABASE_NAMES:-timescaledb}"